// $Id: RandBinomial.inl,v 1.1.1.1 2000/04/03 21:03:45 wilko Exp $
// -*- C++ -*-
// 
// -----------------------------------------------------------------------
//                             HEP Random
//                        --- RandBinomial ---
//                 inlined functions implementation file
// -----------------------------------------------------------------------
 
// =======================================================================
// Gabriele Cosmo - Created: 18th August 1998
// =======================================================================

inline RandBinomial::RandBinomial(HepRandomEngine & anEngine, long n,
                                                              HepDouble p )
: localEngine(&anEngine), deleteEngine(false),
  defaultN(n), defaultP(p) {}

inline RandBinomial::RandBinomial(HepRandomEngine * anEngine, long n,
                                                              HepDouble p )
: localEngine(anEngine), deleteEngine(true),
  defaultN(n), defaultP(p) {}

inline HepDouble RandBinomial::shoot() {
  return shoot( 1, 0.5 );
}

inline HepDouble RandBinomial::shoot( HepRandomEngine* anEngine ) {
  return shoot( anEngine, 1, 0.5 );
}

inline HepDouble RandBinomial::operator()() {
  return fire( defaultN, defaultP );
}

inline HepDouble RandBinomial::operator()( long n, HepDouble p ) {
  return fire( n, p );
}

inline HepDouble RandBinomial::fire() {
  return fire( defaultN, defaultP );
}
