// $Id: RandChiSquare.inl,v 1.1.1.1 2000/04/03 21:03:45 wilko Exp $
// -*- C++ -*-
// 
// -----------------------------------------------------------------------
//                             HEP Random
//                        --- RandChiSquare ---
//                 inlined functions implementation file
// -----------------------------------------------------------------------
 
// =======================================================================
// Gabriele Cosmo - Created: 19th August 1998
// =======================================================================

inline RandChiSquare::RandChiSquare(HepRandomEngine & anEngine, HepDouble a)
: localEngine(&anEngine), deleteEngine(false), defaultA(a)
  {}

inline RandChiSquare::RandChiSquare(HepRandomEngine * anEngine, HepDouble a)
: localEngine(anEngine), deleteEngine(true), defaultA(a)
  {}

inline HepDouble RandChiSquare::fire() {
  return fire( defaultA );
}

inline HepDouble RandChiSquare::shoot() {
  return shoot( 1.0 );
}

inline HepDouble RandChiSquare::operator()() {
  return fire( defaultA );
}

inline HepDouble RandChiSquare::operator()( HepDouble a ) {
  return fire( a );
}

inline HepDouble RandChiSquare::shoot( HepRandomEngine* anEngine ) {
  return shoot( anEngine, 1.0 );
}
