// $Id: RandExponential.inl,v 1.1.1.1 2000/04/03 21:03:45 wilko Exp $
// -*- C++ -*-
// 
// -----------------------------------------------------------------------
//                             HEP Random
//                       --- RandExponential ---
//                 inlined functions implementation file
// -----------------------------------------------------------------------
// This file is part of Geant4 (simulation toolkit for HEP).
 
// =======================================================================
// Gabriele Cosmo - Created: 19th August 1998
// =======================================================================

inline RandExponential::RandExponential(HepRandomEngine & anEngine,
                                        HepDouble mean )
: localEngine(&anEngine), deleteEngine(false), defaultMean(mean) {}

inline RandExponential::RandExponential(HepRandomEngine * anEngine,
                                        HepDouble mean )
: localEngine(anEngine), deleteEngine(true), defaultMean(mean) {}

//-------------

inline HepDouble RandExponential::shoot(HepRandomEngine* anEngine) {
  return -log(anEngine->flat());
}

inline HepDouble RandExponential::shoot(HepRandomEngine* anEngine,
                                        HepDouble mean) {
  return -log(anEngine->flat())*mean;
}

//-------------

inline HepDouble RandExponential::fire() {
  return -log(localEngine->flat())*defaultMean;
}

inline HepDouble RandExponential::fire(HepDouble mean) {
  return -log(localEngine->flat())*mean;
}
