// $Id: RandGamma.inl,v 1.1.1.1 2000/04/03 21:03:45 wilko Exp $
// -*- C++ -*-
// 
// -----------------------------------------------------------------------
//                            HEP Random
//                         --- RandGamma ---
//                 inlined functions implementation file
// -----------------------------------------------------------------------
 
// =======================================================================
// Gabriele Cosmo - Created: 19th August 1998
// =======================================================================

inline RandGamma::RandGamma(HepRandomEngine & anEngine, HepDouble k,
                                                        HepDouble lambda )
: localEngine(&anEngine), deleteEngine(false),
  defaultK(k), defaultLambda(lambda) {}

inline RandGamma::RandGamma(HepRandomEngine * anEngine, HepDouble k,
                                                        HepDouble lambda )
: localEngine(anEngine), deleteEngine(true),
  defaultK(k), defaultLambda(lambda) {}

inline HepDouble RandGamma::shoot() {
  return shoot( 1.0, 1.0 );
}

inline HepDouble RandGamma::shoot( HepRandomEngine* anEngine ) {
  return shoot( anEngine, 1.0, 1.0 );
}

inline HepDouble RandGamma::operator()() {
  return fire( defaultK, defaultLambda );
}

inline HepDouble RandGamma::operator()( HepDouble k, HepDouble lambda ) {
  return fire( k, lambda );
}

inline HepDouble RandGamma::fire() {
  return fire( defaultK, defaultLambda );
}
