// $Id: RandPoisson.inl,v 1.1.1.1 2000/04/03 21:03:46 wilko Exp $
// -*- C++ -*-
// 
// -----------------------------------------------------------------------
//                             HEP Random
//                        --- RandPoisson ---
//                 inlined functions implementation file
// -----------------------------------------------------------------------
// This file is part of Geant4 (simulation toolkit for HEP).
 
// =======================================================================
// Gabriele Cosmo - Created: 19th August 1998
// =======================================================================

inline RandPoisson::RandPoisson(HepRandomEngine & anEngine, HepDouble m )
: localEngine(&anEngine), deleteEngine(false),
  oldm(-1.0), meanMax(2.0E9), defaultMean(m) {
  status[0] = status[1] = status[2] = 0.;
}

inline RandPoisson::RandPoisson(HepRandomEngine * anEngine, HepDouble m )
: localEngine(anEngine), deleteEngine(true),
  oldm(-1.0), meanMax(2.0E9), defaultMean(m) {
  status[0] = status[1] = status[2] = 0.;
}
