#include "Event/algConditionalTask.h"

#include "Event/selectionManager.h"
#include "Event/processManager.h"
#include "Event/messageManager.h"

//##############################
void algConditionalTask::defineOption()
//##############################
{
	/*! "addCut" option set the cut of the algorithmConditional */
	optionVI::defineOption("addCut",&m_cutName);
	/*! "addAlgorithm" option ser the algorithm of the algorithmConditional */
	optionVI::defineOption("addAlgorithm",&m_algName);
}
//##############################
void algConditionalTask::setOption(std::string task, std::string con)
//##############################
{
	optionVI::setOption(task,con);
	if (task=="addCut") {
		cutVI* cut = selectionManager::instance()->getCut(con);
		setCut(cut);
		message(" added cut "+con+" into algConditionalTask named "+name());
	} else if (task=="addAlgorithm") {
		algorithmVI* alg = processManager::instance()->getAlgorithm(con);
		setAlgorithm(alg);
		message(" added algorithm "+con+" into algConditionalTask named "+name());
	}
}
//##############################
void algConditionalTask::writeOut() const
//##############################
{
	if (!acceptLevel()) return;
	messageVI::writeOut();
	std::ostream& out = messageManager::instance()->out();
	out << " algConditionalTask cut name " << m_cutName <<"\n";
	out << " algConditionalTask algorithm name " << m_algName <<"\n";
}
