#include "Event/algorithmTask.h"
#include "Event/processManager.h"
#include "Event/messageManager.h"

//#####################################
void algorithmTask::defineOption()
//#####################################
{
	optionVI::defineOption("addAlgorithm",&m_algName);
}
//#####################################
void algorithmTask::setOption(std::string task, std::string algName)
//#####################################
{
	optionVI::setOption(task,algName);
	if (task == "addAlgorithm") {
		/*! add an algorithm into the algorithmComposite*/
		algorithmVI* alg = processManager::instance()->getAlgorithm(algName);
		if (alg == 0) return;
		algorithmComposite::add(algName,alg);
		message(" added "+algName+" into algorithmTask "+name(),"RELEASE");
	}
}
//#####################################
void algorithmTask::writeOut() const
//#####################################
{
	if (!acceptLevel()) return;
	if (algorithmComposite::size() == 0 ) return;
	std::ostream& out = messageManager::instance()->out();
	messageVI::writeOut();
	out << " -- Algorithms in algorithmTask: "<< name() <<" -- " <<"\n";
	out << nameList();
}
