#ifndef algorithmTask_h
#define algorithmTask_h

#include "Event/algorithmComposite.h"
#include "Event/serviceI.h"

//----------------------------------
//! A algorithmTask is a algorithmComposite whith the system services
/*! 
\c algorithmTask is an algorithmVI and an algorithmComposite.<br>
\b users can add dinamically algorithms using the services of serviceI.
<ul>
	<li> To be declared into the system servers, every algorithmTask object should have a name (\c setName() method of serviceI).
	<li> \b user can add algorithms to the algorithm composite via the
	service of serviceI (optionVI). Use option \c "addAlgorithm".
	<li> the \c setOption() method from optionVI allows an external user 
	(optionManager) to add dinamically algorithms to the algorithmComposite.
</ul>
*/
//------------------------------
// JA Hernando 05/15/00
//------------------------------
	
//##############################
class algorithmTask: public algorithmComposite, public serviceI
//##############################
{
public:

	
	//! constructor - set a name
	algorithmTask(std::string name) {m_algName = ""; setName(name);}
	//! destructor
    virtual ~algorithmTask(){};

	//! information of this class
	virtual void writeOut() const;

protected:

	//! define the options 
	virtual void defineOption();
	//! set options: declated operation: add algorithmVI into algorithmComposite
	virtual void setOption(std::string add, std::string algName);

private:

	//! dummy - last cut in composite, for optionVI
	std::string m_algName;
};
#endif