#ifndef algorithmTree_h
#define algorithmTree_h

#include "Event/algorithmVI.h"
#include "Event/algorithmComposite.h"
//----------------------------------
//! A multialgorithm whith algorithmComposite s in the initialize, execute and finalize methods.
/*!
The initialize(), execute() and finalize() methods run their respective algorithmComposite.
*/
//---------------------------------
//   J.A Hernando   Santa Cruz, 06/06/00
//---------------------------------
	
//#################################
class algorithmTree : public algorithmVI
//#################################
{
public:

	//! constructor - create the algorithmComposite s
	algorithmTree();
	//! destructor - destroies the algorithmComposite s
	virtual ~algorithmTree();

	//! the initalize() method runs the ini algorithmComposite
	virtual void initialize() {m_ini->run();}
	//! the execute() method runs the exe algorithmComposite
	virtual void execute()    {m_exe->run();}
	//! the finalize method runs the fin algorithmComposite
	virtual void finalize()   {m_fin->run();}

protected:

	//! returns algorithmComposite for the initialize algorithms
	algorithmComposite* iniAlg() const {return m_ini;}
	//! returns algorithmComposite for the execute algorithms
	algorithmComposite* exeAlg() const {return m_exe;}
	//! retruns algorithmComposite for the finalize algorithms
	algorithmComposite* finAlg() const {return m_fin;}

private:

	//! algorithmComposite for the initialize algorithms
	algorithmComposite* m_ini;
	//! algorithmComposite for the execute algorithms
	algorithmComposite* m_exe;
	//! algorithmComposite for the finalize algorithms
	algorithmComposite* m_fin;

};
#endif
