#ifndef centellaAlg_h
#define centellaAlg_h

#include "Event/algorithmTree.h"
#include "Event/defineVI.h"

//-----------------------------------------------
//! centella algorithm and program aplication
/*!  
\c centellaAlg is an algorithmVI.<br>
\c centellaAlg runs an application to process <b> RUN </b> data. <br>
<ul>
	<li> centellaAlg is an algorithmTree that runs: 
	<ul>
		<li> Execution of some initial algorithms
		<ul>
			<li> Apply the options
			<li> Open the Input/Output files
			<li> Load the calibration files
			<li> \e User defined algorithms in algorithmTask \e "iniOfRun".
		</ul>
		<li> Execution of the runAlgRun to run a <b> Run </b>
		<li> Execution of some final algorithms
		<ul>
			<li> \e User defined algorithms in algorithmTask \e "endOfRun"
			<li> Close the Input/Output files
		</ul>
	</ul>
	<li> It uses the defineVI base class to define the algorithms of the tree.
</ul>
*/
//--------------------------------------------
//   J.A Hernando   Santa Cruz, CA, 06/06/00	
//-----------------------------------------------
//###############################################
class centellaAlg : public algorithmTree, public defineVI
//###############################################
{
public:

	//! default constructor 
	centellaAlg() {}
	//! default destructor
	virtual ~centellaAlg() {}

	//! overwrite the initialize method to ask for define.
	virtual void initialize();

private:

	//! define the class using other algorithms
	virtual void define();

};
#endif
