
#ifndef CUTCOMPOSITE_H
#define CUTCOMPOSITE_H

#include "Event/cutVI.h"
#include "Event/serverVI.h"
//-------------------------------
//! A composite of cuts.
/*!
\e cutComposite is a cutVI.<br>
\e cutComposite is a composite of cuts. 
<ul>
	<li> Its \c apply() method executes and AND of all cuts in the composite.
	<li> The cuts are served via a serverVI. That means that an individual
	cut can be retreived using its name (via the \c get(name) method of serverVI).
</ul>
*/
//-------------------------------
// JA Hernando, Santa Cruz, CA, 05/15/00
//-------------------------------
//###############################
class cutComposite: public cutVI, public serverVI<cutVI>
//###############################
{
public:

	//! default constructor
	cutComposite() {}
	//! default destructor
	virtual ~cutComposite() {}

	//! makes and AND of all the cuts in the composite
	virtual bool apply();
};
#endif