#ifndef cutSelectionTask_h
#define cutSelectionTask_h

#include "Event/cutComposite.h"
#include "Event/serviceI.h"
//-------------------------------
//! A cutSelectionTask is a cutComposite with serviceI services.
/*! 
\e cutSelectionTask is a cutComposite and a cutVI.<br>
the <b> user </b> can dinamically add cuts into the cutComposite using
the services of serviceI.
<ul> 
	<li> Every object of cutSelectionTask should have a unique name.
	<li> A user can add cuts into the cutComposite via the \c setOption() 
	methods of optionVI.
</ul>
*/
//------------------------------
// JA Hernando, Santa Cruz, CA, 05/15/00
//------------------------------
//##############################
class cutSelectionTask: public cutComposite, public serviceI
//##############################
{
public:
	
	//! constructor - set a name and recive the services declared in serviceI
	cutSelectionTask(std::string name) { m_cutName = ""; setName(name);}
	//! destructor
    virtual ~cutSelectionTask(){};

	//! write Out the information of this class
	virtual void writeOut() const;

protected:

	//! define the options 
	virtual void defineOption();
	//! operation : add cut into composite
	virtual void setOption(std::string addCut, std::string cutName);

private:

	//! dummy - last cut in composite, for optionVI
	std::string m_cutName;
};
#endif