
#include "Event/cutUserServer.h"

#include "Event/centellaCommands.h"

#include "generation/cutEvtRead.h"
#include "generation/cutEvtScan.h"
#include "analysis/cutGammaTagger.h"
#include "analysis/cutGammaTracker.h"

//####################################
cutUserServer::cutUserServer()
//####################################
{
	createSystemCuts();
	createUserCuts();
}
//####################################
void cutUserServer::createUserCuts()
//###############################
{
	//! Cut to read selected number of events
	add("cutEvtRead", new cutEvtRead());
	add("cutEvtScan", new cutEvtScan());

	//! Cut to select the gamma
	add("cutGammaTagger",   new cutGammaTagger());
	add("cutGammaTracker",  new cutGammaTracker());
}
//####################################
void cutUserServer::createSystemCuts()
//###############################
{
	add("conNextEvent",   new conNextEvent());
}
//####################################
cutUserServer::~cutUserServer()
//####################################
{
	
}