#include "Event/dataManager.h"

#include "Event/dataEventServer.h"
#include "Event/dataDetectorServer.h"
#include "Event/dataIOROOTServer.h"

#include "Event/userDataEvent.h"
#include "Event/userDataDetector.h"

dataManager* dataManager::m_instance = 0;

//##################################
dataManager::dataManager()
//##################################
{
	if (m_instance != 0) return;
	m_instance = this;

	m_evt = new dataEventServer();
	m_det = new dataDetectorServer();
	m_IO = new dataIOServer();

	m_instance = this;
	/*! set the data manager into the system servers */
	setName("dataManager");

	/* create \b user detector data */
	userDataDetector();
	/* create \b user event data */
	userDataEvent();
}
//##################################
dataManager::~dataManager()
//##################################
{
	delete m_det;
	delete m_IO;
	delete m_evt;
}
//##################################
trsDataVI* dataManager::getTrsData(std::string name) const
//##################################
{
	if (det()->getTrsData(name) != 0) return det()->getTrsData(name);
	else if (evt()->getTrsData(name) != 0) return evt()->getTrsData(name);
	message(" not found transient Data named "+name);
	return 0;
}
//##################################
void dataManager::writeOut() const
//##################################
{
	if (!acceptLevel()) return;
	messageVI::writeOut();

	m_det->writeOut();
	m_evt->writeOut();
	m_IO->writeOut();
}
