#ifndef eventComposite_h
#define eventComposite_h

#include "Event/eventVI.h"
#include "Event/serverVI.h"
//---------------------------------
//! A eventComposite of eventVI s. 
/*!
\e eventComposite is an algorithmVI.<br>
\e eventComposite is a eventVI.<br>
\e eventComposite is a composite of eventVI s.<br>
<ul>
	<li> The \c generate(), \c reconstruct(), and \c analyze() methods, execute first
	the algorithms of this eventVI and later the same methods of the
	eventVIs of the serverVI. 
	<li> Note the the run is not overwriten. The run method executes in order
	the generate, reconstruct, analyze commands. It implies that the \c run() method
	executes first all the \c generate() methods, first itself, them the rest of
	the eventVIs in the composite; later executes the \c reconstruct(), again first itself
	and later the others eventVIs; and finally the \c analysis(), in the same order, it executes
	first itselt, later the rest of eventVIs in the composite.
</ul>
*/
//-----------------------------
// JA Hernando, Santa Cruz, CA, 02/15/00
//-----------------------------
//#############################
class eventComposite: public eventVI , public serverVI<eventVI>
//#############################
{
public:

	
	//! default constructor
	eventComposite(){}
	//! defautl destructor
	virtual ~eventComposite() {};  

	//! the method generate, reconstruct, analyze are commands
	/*! this methods execute first the algorithm composite of eventVI,
	and later the method of all the eventVI algorithms in the serverVI via
	the command(name) method.*/
	virtual void generate()    {eventVI::generate();serverVI<eventVI>::command("generate");}
	virtual void reconstruct() {eventVI::reconstruct();serverVI<eventVI>::command("reconstruct");}
	virtual void analyze()     {eventVI::analyze();serverVI<eventVI>::command("analyze");}

};
#endif