#ifndef runRunAlg_h
#define runRunAlg_h

#include "Event/algorithmCommand.h"
#include "Event/defineVI.h"

#include "Event/cutVI.h"
#include "Event/algorithmVI.h"

//------------------------
//! algorithm to run a RUN
/*!
runRunAlg is an algorithm that makes a loop in all the events in persistency
and executed the runEventAlg for everyone of them. <br>
*/
//------------------------
// JA Hernando, Santa Cruz, CA, 05/15/00
//------------------------

//#####################################
class runRunAlg : public algorithmCommand, public defineVI
//#####################################
{
public:

	//! default constructor
	runRunAlg() {}
	//! defautl destrutor
	virtual ~runRunAlg() {}

	//! execute the algorithm
	virtual void execute();
	//! define the algorithm using other algorithms
	virtual void define();

private:

	//! cutVI is next event in persistency?
	cutVI* m_cNextEvent;
	//! algorithmVI to run an event event;
	algorithmVI* m_aRunEvent;
};
#endif