
#include "Event/userAlgorithms.h"

#include "reconstruction/SiClustersAlg.h"
#include "reconstruction/SiRecObjsAlg.h"

#include "reconstruction/CalRecLogsAlg.h"
#include "reconstruction/CalClustersAlg.h"
#include "analysis/CalAnaLogsAlg.h"

#include "analysis/selectionAlg.h"
#include "analysis/tbHeaderAlg.h"
	
//####################################
userAlgorithms::userAlgorithms()
//####################################
{
	/*! get the processManager */
	processManager* pM = processManager::instance();
	
	/*! create and add Algorithms for the Silicon Tracker */
	pM->addAlgorithm("makeSiClusters",   new SiClustersAlg());
	pM->addAlgorithm("makeSiTracks",     new SiRecObjsAlg());

	/*! create and add Algorithms for the calorimter */
	pM->addAlgorithm("makeCalRecLogs",     new CalRecLogsAlg());
	pM->addAlgorithm("makeCalClusters",    new CalClustersAlg());
	pM->addAlgorithm("calculateCalPedestals",  new CalAnaLogsAlg());

	/*! create and add Algorithms for the Tower */	
	pM->addAlgorithm("applySelection",   new selectionAlg());
	pM->addAlgorithm("makeHeader", new tbHeaderAlg());
}