#ifndef userAlgorithms_h
#define userAlgorithms_h

#include "Event/processManager.h"

//---------------------------------------
//! Class left to the user to create his/her algorithms and add them to the processManager
/*! 
\c userAlgorithms should be implemented by the USER
<ul>
	<li> The user algorithms should be created in the constructor of this class. <br>
	<li> The user algorithms should be added into the processManager in the constructor
	of this class. For that use the method \c addAlgorithm() of the processManager. <br>
	<li> All the user algorithms should inherit from algorithmVI.
	<li> See centellaAlgorithms for reference.
</ul>
*/
//----------------------------
// JA Hernando, Santa Cruz, CA, 06/15/00
//----------------------------
//############################
class userAlgorithms
//############################
{
public:
	
	//! constructor - creates the user algorithms and adds them into the processManager.
	/*! see centellaAlgorithms constructor for reference */
	userAlgorithms();
	//! destructor - destroies the algorithms
	~userAlgorithms() {};
};
#endif