#include "Event/userDataDetector.h"

#include "instrument/CalCalibLogs.h"
#include "instrument/CalPedCalib.h"
#include "instrument/SiGeoCalib.h"
#include "instrument/SiCalibLayers.h"

//#################################
userDataDetector::userDataDetector()
//#################################
{
	/*! get the dataDetectorServer */
	dataDetectorServer* DET = dataManager::instance()->det();

	/*! add transient data for the calibration of the calorimeter logs */
	DET->addData("CalCalibLogs", new CalCalibLogs());
	DET->addData("CalPedCalib", new CalPedCalib());
	/*! add transient data for the alignment of the tracker */
	DET->addData("SiGeoCalib", new SiGeoCalib());
	DET->addData("SiCalibLayers", new SiCalibLayers());
}