#include "MyRecon.h"

//! define histograms here 
/*! set up histograms and root file for them here */
void MyRecon::HistDefine() {

   histFile = new TFile("Histograms.root","RECREATE");

   TH1F *NCLUS = new TH1F("NCLUS", "Number of TKR SiClusters",
       500, 0, 500);

  // end histogram definition ________________________________________

}


//! event loop. User analysis goes here.
/*! User must refresh pointers to histograms. */
void MyRecon::Go(Int_t numEvents)
{
//     This is the loop skeleton
//       To read only selected branches, Insert statements like:
// fTree->SetBranchStatus("*",0);  // disable all branches
// fTree->SetBranchStatus("branchname",1);  // activate branchname
   printf("\nNumEvents is: %i\n", numEvents);
   if (fTree == 0) return;

   Int_t nentries = fTree->GetEntries();
   printf("\nNum Events in file is: %i\n", nentries);
   Int_t curI;
   Int_t nMax = TMath::Min(numEvents+m_StartEvent,nentries);
   if (m_StartEvent == nentries) {
     printf(" all events in file read\n");
     return;
   }


// refresh your histogram pointers here ______________________________

   TFile *histFile = (TFile*)gROOT->GetFile("Histograms.root");

   TH1F *NCLUS = (TH1F*)histFile->Get("NCLUS");

   //  end histogram pointer refresh ____________________________________

   Int_t nbytes = 0, nb = 0;
   for (Int_t ievent=m_StartEvent; ievent<nMax; ievent++, curI=ievent) {
       
       if (rec) rec->Clean();

       nb = fTree->GetEvent(ievent);   nbytes += nb;

       // Check that Recon object exists for this event.
       if (!rec) continue;

       // start analysis code _______________________________________
       /////////////
       // Tracker...
       /////////////
       TkrRecon *tkr = rec->getTkrRecon();

       if (tkr) {
           int nClusters = tkr->getSiClusters()->GetEntries();
           NCLUS->Fill(nClusters);

           for (int iCluster = 0; iCluster < nClusters; iCluster++) {
               TkrSiCluster* si = (TkrSiCluster*)(tkr->getSiClusters()->At(iCluster));

           }
       }

   } // end analysis code in event loop ___________________________
   m_StartEvent = curI;
}
