#ifndef SiHistoFolder_h
#define SiHistoFolder_h

#include "Event/rHistoFolder.h"

#include "generation/SiLayers.h"
#include "reconstruction/SiClusters.h"
#include "reconstruction/SiRecObjs.h"

//###############################
class SiHistoFolder : public rHistoFolder
//###############################
{
public:
	
	//! Root Histograms and Ntuples folder for the TKR (tracker) system

	//! constructor
	SiHistoFolder() {m_SiLayers=0;m_SiClusters=0;m_SiRecObjs=0;};
	//! destructor
	~SiHistoFolder() {}

	//! fills the histos/ntuples of this "rHistoFolder"
	/*! if the histos are not defined with "fill()" is called, the "define()" method
	is called before filling */
	virtual void fill();
	//! defines the histos/ntuples of this "rHistoFolder"
	virtual void define();
	
private:

	//! ntuple with the information from the tracker-gamma and the rest of tracks in the event
	void ntupleDefine(SiRecObjs* s);
	void ntupleFill(SiRecObjs* s);

	// histos operations
	//! histograms for the strips
	void histosDefine(SiLayers* s);
	//! histograms for the tracks and gamma-tracker objects
	void histosDefine(SiRecObjs* s);
	void histosFill(SiLayers* s);
	void histosFill(SiRecObjs* s);

private:

	SiLayers*   m_SiLayers;
	SiClusters* m_SiClusters;
	SiRecObjs*  m_SiRecObjs;

};
#endif