#include "RootTree/TowerEndRunHistoFolder.h"

#include "RootTree/rTreeRawServer.h"
#include "Event/dataManager.h"

#include "TFile.h"
#include "TH1.h"
#include "TH2.h"
#include "TNtuple.h"
#include "TROOT.h"

#include "TMath.h"
#include "TObject.h"
#include "TObjArray.h"
#include "TMap.h"

//###############################
void TowerEndRunHistoFolder::define() 
//###############################
{	
	if (defined()) return;
	m_selData = dataManager::instance()->getData("selectionData",m_selData);
	ntupleDefine(m_selData);
	setDefine(true);
}

//###############################
void TowerEndRunHistoFolder::fill() 
//###############################
{	
	if (!defined()) define();
	ntupleFill(m_selData);
}
//###############################
void TowerEndRunHistoFolder::ntupleDefine(selectionData* selData) 
//###############################
{
	getFile()->cd();

	std::string name = selData->cutName(0);
	for (unsigned int iCut = 1; iCut< selData->num();iCut++) name = name+":"+selData->cutName(iCut);
	// char* varname = name.c_str();
	TNtuple* ntSelection = new TNtuple("ntSelection", "Selection info", name.c_str());
}
//###############################
void TowerEndRunHistoFolder::ntupleFill(selectionData* selData) 
//###############################
{
	getFile()->cd();

	const int MAXCUTS = 20;
	int nCut = selData->num();
	Float_t counter[MAXCUTS];
	for (unsigned int iCut = 0; iCut< selData->num();iCut++) counter[iCut] = 1.*(selData->counter(iCut));
	
	((TNtuple*) getFile()->Get("ntSelection"))->Fill(counter);
}
