#ifndef TowerHistoFolder_h
#define TowerHistoFolder_h

#include "Event/rHistoFolder.h"

#include "generation/BeamTagger.h"
#include "reconstruction/SiRecObjs.h"
#include "reconstruction/CsIClusters.h"

//###############################
class TowerHistoFolder : public rHistoFolder
//###############################
{
public:
	
	//! root Histogram and Ntuples folder for the TKR system (Tracker+Calorimeter)

	//! constructor
	TowerHistoFolder() {m_tagger=0; m_cal=0; m_tkr=0;};
	//! destructor
	~TowerHistoFolder() {}

	//! fill the histos/ntuples of this "rHistoFolder"
	virtual void fill();
	//! define the histos/ntuplpes of this 'rHistoFolder"
	virtual void define();
	
private:

	//! ntuple with the gamma information from the tracker, calorimeter and tagger data
	void ntupleDefine(SiRecObjs* s, CsIClusterList* c, BeamTagger* t);
	void ntupleFill(SiRecObjs* s, CsIClusterList* c, BeamTagger* t);

private:

	BeamTagger* m_tagger;
	SiRecObjs* m_tkr;
	CsIClusterList* m_cal;
};
#endif