
#include "analysis/CalAnaLogsAlg.h"
#include "Event/dataManager.h"
#include "instrument/CalADCLogs.h"
#include "analysis/CalAnaLogs.h"


//###################################
void CalAnaLogsAlg::execute()
//###################################
{
	CalAnaLogs* anaLogs = 0;
	anaLogs = dataManager::instance()->getData("CalAnaLogs",anaLogs);
	CalADCLogs* adcLogs = 0;
	adcLogs = dataManager::instance()->getData("CalRawLogs",adcLogs);

	anaLogs->addEntry();
	int numLogs = adcLogs->num();
	for (int ilog = 0; ilog < numLogs; ilog++) {
		CalADCLog* adcLog = adcLogs->Log(ilog);
		int logID = adcLog->logID();
		CalADCLog* anaLog = anaLogs->getLogID(logID);
		
		anaLog->addNegADC(CalBase::LEX,adcLog->ADC(CalBase::NEG,CalBase::LEX));
		anaLog->addNegADC(CalBase::LE, adcLog->ADC(CalBase::NEG,CalBase::LE));
		anaLog->addNegADC(CalBase::HEX,adcLog->ADC(CalBase::NEG,CalBase::HEX));
		anaLog->addNegADC(CalBase::HE, adcLog->ADC(CalBase::NEG,CalBase::HE));

		anaLog->addPosADC(CalBase::LEX,adcLog->ADC(CalBase::POS,CalBase::LEX));
		anaLog->addPosADC(CalBase::LE, adcLog->ADC(CalBase::POS,CalBase::LE));
		anaLog->addPosADC(CalBase::HEX,adcLog->ADC(CalBase::POS,CalBase::HEX));
		anaLog->addPosADC(CalBase::HE, adcLog->ADC(CalBase::POS,CalBase::HE));
	}
}
