
#include "analysis/CalAnaLogsMerit.h"
#include "Event/messageManager.h"
#include "Event/dataManager.h"
#include "analysis/CalAnaLogs.h"
#include "instrument/CalPedCalib.h"

//###################################
void CalAnaLogsMerit::execute()
//###################################
{
	normaAnaLogs();
	CalAnaLogs* anaLogs = 0;
	anaLogs = dataManager::instance()->getData("CalAnaLogs",anaLogs);

	anaLogs->writeOut();
	std::ostream& out = messageManager::instance()->out();
	CalPedCalib* pedLogs = 0;
	pedLogs = dataManager::instance()->getData("CalPedCalib",pedLogs);

	std::vector<int> idList;
	for (int ilog = 0; ilog < anaLogs->num(); ilog++) {
		idList.clear();
		CalADCLog* anaLog = anaLogs->Log(ilog);
		int logID = anaLog->logID();
		CalADCLog* pedLog = pedLogs->getLogID(logID);
		for (int jlog = 0; jlog < anaLogs->num(); jlog++) {
			anaLog = anaLogs->Log(jlog);
			if (compare(pedLog,anaLog)) idList.push_back(anaLog->logID());
		}

		out << logID << "-" << anaLog->layer() << anaLog->view() << anaLog->column() << " -> ";
		for (int i = 0; i < idList.size(); i++) {
			out << idList[i] << "-";
			out << CalLogID::layer(idList[i]);
			out << CalLogID::view(idList[i]);
			out << CalLogID::column(idList[i]);
			out << " ";
		}
		out << "\n";

	}
}
//###################################
bool CalAnaLogsMerit::compare(const CalADCLog* pedLog, const CalADCLog* anaLog)
//###################################
{
	bool ok = true;
	double COMPARELIMIT = 5;
	for (int iside = 0 ; iside < CALNSIDES; iside++) {
		for (int irange = 0; irange < CALNRANGES ; irange++) {
			double ped = pedLog->ADC(CalBase::side(iside),CalBase::range(irange));
			double adc = anaLog->ADC(CalBase::side(iside),CalBase::range(irange));
			if (fabs(ped-adc)>COMPARELIMIT) ok = false;
			if (!ok) break;
		}
	}
	return ok;
}

//###################################
void CalAnaLogsMerit::normaAnaLogs()
//###################################
{
	CalAnaLogs*  anaLogs = 0;
	anaLogs = dataManager::instance()->getData("CalAnaLogs",anaLogs);
	double entries = anaLogs->numEntries();
	for (int ilog = 0; ilog < anaLogs->num(); ilog++){
		CalADCLog* anaLog = anaLogs->Log(ilog);
		for (int irange = 0; irange < CALNRANGES ; irange++) {
			anaLog->setNegADC(CalBase::range(irange),
				(anaLog->ADC(CalBase::NEG,CalBase::range(irange)))/entries);
			anaLog->setPosADC(CalBase::range(irange),
				(anaLog->ADC(CalBase::POS,CalBase::range(irange)))/entries);
		}
	}
}
