
#include "analysis/selectionData.h"
#include "Event/selectionManager.h"
#include "Event/messageManager.h"

//####################################
void selectionData::ini()
//####################################
{
	cutComposite* selection = selectionManager::instance()->getCutComposite("selWrite");
	m_cutsList.push_back("total");
	m_counter.push_back(0);
	unsigned int numCuts = selection->num();
	unsigned int iCut = 0;
	for (iCut = 0; iCut < numCuts; iCut++ ) {
		m_cutsList.push_back(selection->getName(iCut));
		m_counter.push_back(0);
	}
}
//####################################
void selectionData::clear()
//####################################
{
	unsigned int numCuts = m_cutsList.size();
	unsigned int iCut = 0;
	for (iCut = 0; iCut < numCuts; iCut++) m_counter[iCut] = 0;

	setValid(true);
}
//################################################
void selectionData::writeOut() const
//################################################
{
	std::ostream& out = messageManager::instance()->out();
	if (!messageManager::instance()->acceptLevel("GENERAL")) return;

	unsigned int nCut = num();
	unsigned int iCut = 0;
	out << " --- Selection Data --- " << "\n";
	for (iCut = 0; iCut < nCut; iCut++) {
		out << m_cutsList[iCut] << " " << m_counter[iCut] << "\n";
	}
}
