#ifndef tbHeader_h
#define tbHeader_h

#include "Event/trsDataVI.h"
//! data with the event header information

//###################################
class tbHeader : public trsDataVI
//###################################
{
public:

	//! default constructor
	tbHeader() {ini();}
	//! default destructor
	~tbHeader() {}

	//! set the event value
	void setEvent(int ievt)    {m_idevent = ievt;}
	//! set the track info
	void setInfoTkr(int tkr)   {m_infoTkr = tkr;}
	//! set the calorimeter info
	void setInfoCal(int cal)   {m_infoCal = cal;}

	//! get the event id
	int getEvent()   const {return m_idevent;}
	//! get the track info
	int getInfoTkr() const {return m_infoTkr;}
	//! get the calorimeter info
	int getInfoCal() const {return m_infoCal;}

	//! clear - set to null the variables
	virtual void clear() {m_idevent=0;m_infoTkr=0;m_infoCal=0;}

protected:

	//! ini equal to clear
	virtual void ini() {clear();}
	//! null make
	virtual void make() {}

private:

	//! information about the event
	int m_idevent;
	//! information about the track
	int m_infoTkr;
	//! information about the calorimter
	int m_infoCal;
};
#endif