#ifndef tbHeaderAlg_h
#define tbHeaderAlg_h

#include "Event/algorithmVI.h"
#include "Event/defineVI.h"

#include "generation/rawEventID.h"
#include "analysis/tbHeader.h"
#include "reconstruction/SiRecObjs.h"


//! algorithm to set the event header flags
 
//##############################
class tbHeaderAlg: public algorithmVI, public defineVI
//##############################
{
public:
	//! default constructor
	tbHeaderAlg() {}
	//! default destructor
	~tbHeaderAlg() {}

	//! clear the data
	virtual void initialize();
	//! fill the information of the tbHeader
	virtual void execute();
	//! null finalize
	virtual void finalize() {}

	//! take the pointers
	virtual void define();

private:

	//! pointer to tbHeader
	tbHeader* m_tbHeader;
	//! pointer to siRecObjs
	SiRecObjs* m_sirecs;
	//! pointer to rawEventID
	rawEventID* m_rawEvtID;
};
#endif