// $Header: /cvs/tb_recon/centella/main.cpp,v 1.8 2000/07/19 21:11:58 heather Exp $
// Main program for glastsim application


//#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include "TROOT.h"
#include "Event/centellaSys.h"
#include "Event/optionManager.h"
#include "Event/processManager.h"

// insert some debug code to be used to 
// hunt down memory leaks
#if defined(_DEBUG) && defined (_MSC_VER)
#  include <CRTDBG.H>
#endif

void main(int argc, char* argv[])
{

    // setup a breakpoint for the nth memory allocation
    // that the debugger reported was leaked.
#if defined(_DEBUG) && defined (_MSC_VER)
    //_CrtSetBreakAlloc(1051);
    //_crtBreakAlloc = 1051;
#endif

	TROOT rootSys("tree","example");

	centellaSys* centella = new centellaSys();

	optionManager::instance()->setOption(argc, argv);

	processManager::instance()->runApplication();

    // let's clean up
    delete centella;

    // stolen code from GLASTSIM
#if defined(_DEBUG) && defined (_MSC_VER)
    // this to verify that memory has been released
    _CrtSetDbgFlag( _CrtSetDbgFlag( _CRTDBG_REPORT_FLAG ) | _CRTDBG_LEAK_CHECK_DF);
#endif

}
