//---------------------------------------------------
//
//    WinGUI application for 
//           
//    Standarlone Tracking 99-00 GLAST test beam
//
//
//               J.A Hernando, R. Johnson, W. Kroeger
//               Santa Cruz, CA, 12/17/99 
//----------------------------------------------------

//----------------------------------------------------
//
//   Set Active Project "centellaGUI" for GUI
//   Set Active Project "centella" for console
//
//   
//----------------------------------------------------

#include "centellaGUI/AppliGUI.h"
#include "Event/centellaSys.h"
#include "Event/optionManager.h"
#include "Event/processManager.h"

//############################################
appliGUI::appliGUI(int argc, char* argv[])
//############################################
{
	// create display and output wi
	// create centella ntuple

	cenSys = new centellaSys();

	m_graphicsManager = new graphicsManager();
	m_graphicsManager->define();
}

//############################################
appliGUI::~appliGUI()
//############################################
{
	delete m_graphicsManager;
    delete cenSys;
}
//############################################
void appliGUI::run()
//############################################
{
	processManager::instance()->getAlgorithm("centellaAlg")->initialize();
	graphicsManager::instance()->run();
}
