#ifndef GRAPHICSMANAGER_H
#define GRAPHICSMANAGER_H

#include "graphics/GUI.h"
#include "control/Menu.h"
#include "graphics/DisplayControl.h"
#include "graphics/ArveDisplayer.h"
#include "graphics/ArvePlottableRep.h"
#include "control/PrintControl.h"
#include "control/Command.h"

//#######################################
class graphicsManager
//#######################################
{

public:

	// constructor
	graphicsManager();
	~graphicsManager();

	// access
	static graphicsManager* instance() {return m_instance;}
	
	// operations
	void define();
	void run();
	void update();

private:
	
	static graphicsManager* m_instance;

	// display
	GUI*	        m_gui; 
    DisplayControl* m_display;
    PrintControl*   m_print;
    Menu*	        m_menu;
};

//###################################
class One : public Command
//###################################
{
public:

	void execute();
};
//###################################
class Rec : public Command
//###################################
{
public:

	void execute();
};

//###################################
class Go : public Command
//###################################
{
public:

	void execute();
};

#endif

