
#ifndef __SILAYERS_H
#define __SILAYERS_H 1

// #include <stdlib.h>
#include <iostream>
#include <vector>
#include "Event/trsDataVI.h"


//----------------------------------------------
//
//   SiLayers
//
//   Transient Storage Clases
//----------------------------------------------
//   It contains the Raw tracker data
//----------------------------------------------
//             J.A Hernando, Santa Cruz 02/29/00
//----------------------------------------------
//##############################################
class SiLayer
//##############################################
{
public:

	//construct
	SiLayer(int layer, int iview, int ToT = -1);
	~SiLayer() {clear();}
	
	inline void setToT(int ToT) {m_ToT = ToT;}
	void addStrip(int istrip);

	// access
	inline int ToT() const   {return m_ToT;} 
	inline int layer() const {return m_layer;} 
	inline int view() const  {return m_view;}

	// access list
	inline int nstrips()      {return m_stripList.size();}
	inline int idstrip(int i) {return m_stripList[i];}

	// operations
	void clear()              {m_stripList.clear();}
	void writeOut() const;

private:

	// operations
	bool validStrip(int istrip);

private:

	int m_view;
	int m_layer;

	int m_ToT;

	std::vector<int> m_stripList;

};

//##############################################
class SiLayers : public trsDataVI
//##############################################
{
public:

	// constructor
	SiLayers() {ini();}
	~SiLayers() {clear();}

	void add(SiLayer* sd)   {m_SiLayersList.push_back(sd);}

	// data operations
	virtual void clear();
	virtual void make() {} 
	
	// access
	int numStrips();
	SiLayer* getSiLayer(int ilayer, int iview);

	// access list
	int num()             const {return m_SiLayersList.size();}
	SiLayer* Layer(int i) const {return m_SiLayersList[i];}

	// operations
	void writeOut() const;

protected:

	virtual void ini();

private:

	std::vector<SiLayer*>  m_SiLayersList;

};

#endif
