
#include "generation/cutEvtRead.h"
#include "Event/dataManager.h"

#include "Event/optionManager.h"

//######################################
cutEvtRead::cutEvtRead()
//######################################
{
	m_nEvtRead = -1;
	m_nEvtSkip = 0;

	setName("cutEvtRead");
}
//######################################
bool cutEvtRead::apply()
//######################################
{
	bool valid = true;
	if (m_nEvtRead < 0) return true;
	int ievt = dataManager::instance()->IO()->eventNumber();
	if (ievt < m_nEvtSkip) return false;
	if (ievt > m_nEvtSkip+m_nEvtRead) return false;
	return valid;
}
//######################################
void cutEvtRead::defineOption()
//######################################
{
	optionVI::defineOption("nEvtSkip",&m_nEvtSkip);
	optionVI::defineOption("nEvtRead",&m_nEvtRead);
}
