// $Id: Shape.cxx,v 1.1.1.1 2000/04/03 21:03:54 wilko Exp $
//

#include "Shape.h"
#include "control/error.h"
#include <strstream>

// implementations of Shape member functions

Shape::Shape()
{}


Shape& Shape::copy()const
{
    std::ostrstream msg;
    msg << "The Shape subclass " << nameOf() 
	<< " did not implement a copy() method\0";
    FATAL(msg.str());
    return *(Shape*)this; //(just to make compiler happy)

}


void
Shape::printOn(std::ostream& os)const
{
  os << "Shape is a " << nameOf()
	  <<  " centered at: " << center() <<std::endl;
}

GeomObject&
Shape::transform(const CoordTransform& T)
{
  _center.transform(T);
  return *this;
}

