// $Id: Surface.cxx,v 1.1.1.1 2000/04/03 21:03:54 wilko Exp $
//


#include "Surface.h"
#include "control/error.h"
#include <strstream>

GeomObject&
Surface::transform(const CoordTransform& T )
{
  referenceDirection.transform(T);
  return *this;
}
void
Surface::reverse()
{
    referenceDirection *= -1;
}

// copy constructor uses same reference point, makes a copy of
// direction, then has the subclass do the rest (if it can)
Surface::Surface(const Surface& old)
    :referencePoint(old.referencePoint)
    ,referenceDirection(old.referenceDirection)
{ 
}

// this to not force all surfaces to copy, but crash if can't
Surface& Surface::copy()const
{
    std::ostrstream msg;
    msg << "The Surface subclass " << nameOf() 
	<< " did not implement a copy() method\0";
    FATAL(msg.str());
    return *(Surface*)this; //(just to make compiler happy)
}

