//     $Id: Arve2D.h,v 1.1.1.1 2000/04/03 21:03:55 wilko Exp $
//  Author: T. Burnett
// Project: Arve graphics

#ifndef ARVE2D_H
#define ARVE2D_H 1


#include "graphics/ArvePlottableRep.h"
#include "graphics/ViewPort.h"
#include "CLHEP/Vector/ThreeVector.h"

class Arve2D : public ArvePlottableRep {
    //Special Rep that draws directly to the canvas: subclass must implemnt
    // the draw(Draw2D*) method
public:

    virtual void draw(ViewPort* port);
    // override to draw directly to the canvas, accessible from the ViewPort

    virtual void draw(Draw2D* canvas)=0;
    // subclass must define to draw directly to the canvas

    virtual void update(){};
    // must define to be an ArvePlottableRep: however, drawing is done with the draw above

private:

};

inline void Arve2D::draw(ViewPort* port)
{
    if( !hidden() ) draw(port->canvas());
}

#endif
