// $Header: /cvs/tb_recon/graphics/ArvePlottable.cxx,v 1.3 2000/05/11 18:58:33 hernando Exp $
//  Author: Toby Burnett
// Project: Arve display

#include "ArvePlottable.h"
#include "graphics/ArvePlottableRep.h"


#include "display/PlottableModel.h"
#include "display/AbstractScene.h"
#include "ArveScene.h"
#include <assert.h>

class ArvePlottable::SimpleRep : public ArvePlottableRep {
friend class SimpleModel;
	SimpleRep( const ArvePlottable* object) :m_object(object){}
	void update(){m_object->draw(*this);}
	const ArvePlottable* m_object;
};

class ArvePlottable::SimpleModel : public PlottableModel {
friend class ArvePlottable;
	SimpleModel(const ArvePlottable* thing):m_arve_rep(new SimpleRep(thing)){}
	~SimpleModel(){delete m_arve_rep;}
	PlottableRep* representation(const AbstractScene& s)const
	{ return s.type()==AbstractScene::ARVE? m_arve_rep : 0 ;
	}
	void update(AbstractScene& s){if(s.type()==AbstractScene::ARVE )m_arve_rep->update();}
	void clear(AbstractScene& s){if(s.type()==AbstractScene::ARVE )m_arve_rep->clear();}
	void display(AbstractScene& s){if(s.type()==AbstractScene::ARVE )assert(0);}
	void remove(AbstractScene& s){if(s.type()==AbstractScene::ARVE )assert(0);}
	SimpleRep* m_arve_rep;
};

static bool local_flag;
PlottableModel*
ArvePlottable::model()const{local_flag=true;  return new SimpleModel(this); }

void
ArvePlottable::draw(ArvePlottableRep& v)const
// this is called if the derived class does not implement a draw.
// Check to see if there is a model
{
    local_flag = false;
    PlottableModel* m = model();

    if( local_flag ) {
	delete m;
	return;
    }
    // ok, it is not a SimpleModel. Add the VwDisp nodes to this

    PlottableRep* r = m->representation(ArveScene());
    delete m;  // assume that model() 's return can be deleted!
    if(r) {
#if !HAVE_TYPEID
	ArvePlottableRep* vl = (ArvePlottableRep*)(r);
#else
	ArvePlottableRep* vl = dynamic_cast<ArvePlottableRep*>(r);
#endif
	vl->update();
	v.append(*vl);
	delete vl;
    }
}


