// $Header: /cvs/tb_recon/graphics/ArvePlottable.h,v 1.1.1.1 2000/04/03 21:03:55 wilko Exp $
//  Author: Toby Burnett
// Project: Arve display

// define a Plottable class that allows a subclass to define a method
//
//    void draw(ArvePlottableRep&)const;
//
// thus avoiding any overhead from the system. It is not necessary to define
// a model() function member, but one can be written to override this system

#ifndef ARVEPLOTTABLE_H
#define ARVEPLOTTABLE_H 

#include "arve/config.h"
#include "display/Plottable.h"
class ArvePlottableRep;

class ArvePlottable : public Plottable
{
public:
    // Implicit constructor
    // Implicit copy constructor
    // Implicit assignment operator
    virtual ~ArvePlottable(){}

    virtual void draw(ArvePlottableRep&)const;
    // if overriden, and model() is not, allows representation with just one function

    virtual PlottableModel* model()const;
    // return a model for this object, that will be able to display it, using
    // the virtual draw(ArvePlottableRep&) method.
private:
    class SimpleModel;
    class SimpleRep;
    friend class SimpleModel;
};

#endif // ARVEPLOTTABLE_H
