// $Header: /cvs/tb_recon/graphics/ArvePlottableModel.h,v 1.1.1.1 2000/04/03 21:03:55 wilko Exp $
//  Author: Toby Burnett
// Project: Arve graphics
//
// Define the class ArvePlottableModel, inheriting from PlottableModel in order to
// interface the ATLAS eventdisplay design to the simplified graphics in Arve.
// Note that there is only one PlottableModel for Avre simplified graphics, which 
// deals with the graphics primitives points, lines, surfaces, and text. Higher-level
// entities such as spheres, cones, and cylinders are not supported. See the
// class DisplayList for a complete list. 


#ifndef ARVEPLOTTABLEMODEL_H
#define ARVEPLOTTABLEMODEL_H

#include "arve/config.h"
#include "display/PlottableModel.h"

class ArvePlottableModel : public PlottableModel
{
public:
    // Implicit constructor
    // Implicit copy constructor
    // Implicit destructor

    virtual void plot(AbstractScene& scene);
    virtual void update(AbstractScene& scene);
    virtual void remove(AbstractScene& aScene);

    virtual PlottableRep * representation(const AbstractScene& scene)=0;
};
#endif //ARVEPLOTTABLEMODEL_H

