// $Header: /cvs/tb_recon/graphics/ArveScene.cxx,v 1.1.1.1 2000/04/03 21:03:56 wilko Exp $
//  Author: Toby Burnett
// Project: Arve


#include "ArveScene.h"
#include <algorithm>


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ArveScene::ArveScene()
    :m_enabled(true)
{}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ArveScene::~ArveScene()
{
    RepList::iterator irep = m_replist.begin();
    while( irep != m_replist.end() ) {
	delete (*irep++);
    }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ArveScene::add(ArvePlottableRep* pRep)
//-----------------------------------------
{
    m_replist.push_back(pRep);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ArveScene::remove(ArvePlottableRep* pRep)
//--------------------------------------------
{
     RepList::iterator it;
     it= std::find(m_replist.begin(), m_replist.end(), pRep);
     if( it != m_replist.end() )	m_replist.erase(it);

}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ArveScene::clear()
//---------------------
{
    if(! m_enabled)  return;

    RepList::iterator irep = m_replist.begin();
    while( irep != m_replist.end() ) {
	(*irep++)->clear();
    }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ArveScene::update()
//-----------------------
{
    if( !m_enabled) return;
    RepList::iterator irep = m_replist.begin();
    bool updated = false;
    while( irep != m_replist.end() ) {
	if( !(*irep)->hidden() ) {
	    (*irep)->update();
	    updated = true;
	}
	++irep;
    }
    //(need something like this?) if( updated) redisplay();
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ArveScene::enable()
{
    m_enabled = true;
    update();
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ArveScene::disable()
{
    m_enabled = true;
    clear();
    m_enabled = false;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ArveScene::draw(ViewPort* v)
//--------------------------------
{
    RepList::iterator it=m_replist.begin();
    while( it != m_replist.end() ) (*it++)->draw(v);
}


