//     $Id: ArveScene.h,v 1.1.1.1 2000/04/03 21:03:56 wilko Exp $
//  Author: Toby Burnett
// Project: Arve graphics
//

#ifndef ARVESCENE_H
#define ARVESCENE_H

#include "ArvePlottableRep.h"
#include <list>
class ViewPort;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
class ArveScene 
// THis class used to inherit from the Scene of Atlas graphics, but was dis-inherited
{
public:
    ArveScene();
    ~ArveScene();
    
  
    void add(ArvePlottableRep*);
    // add to the rep to the list to display 
	
    void remove(ArvePlottableRep*);
    // remove from the list

    void draw(ViewPort *v);
    // have the members of the list draw themselves onto the ViewPort

    void clear();
    // send clear message to all attached reps

    void update();
    // ask all representations to update

    void enable();
    // enable the display

    void disable();
    // disable the display

    bool enabled()const;
    // return enabled status


private:
    typedef std::list<ArvePlottableRep*> RepList;
    RepList m_replist;	// list of Reps
    
    bool    m_enabled;	// can disable display 

};
//////// inlines //////////////////
inline bool ArveScene::enabled()const{return m_enabled;}
#endif //ARVESCENE_H






