//     $Id: Axes.cxx,v 1.1.1.1 2000/04/03 21:03:56 wilko Exp $
// Project: Arve grahics
//  Author: Toby Burnett
//

// Axis display Implementation

#include "Axes.h"
#include "CLHEP/Vector/ThreeVector.h"
#include "graphics/ArvePlottableRep.h"
#include "display/PlottableModel.h"
#include "display/AbstractScene.h"


static Hep3Vector unitvector[3] =
	{Hep3Vector(1.,0.,0.),
	 Hep3Vector(0.,1.,0.),
	 Hep3Vector(0.,0.,1.)
	};
static const char* axislabel[3]={"x","y","z"};


class ArveAxes : public ArvePlottableRep
{
public:
    ArveAxes(double scale)
    {
	for( int i=0; i<3; i++){
	    move_to(Hep3Vector(0,0,0));
	    line_to((scale)*unitvector[i]);
	    drawText(axislabel[i]);
	}
	flush();
    }
    void update(){};
    void clear(){};
};

class Axes::Model : public PlottableModel {
public:
    Model(float s):m_size(s){}
    PlottableRep* representation(const AbstractScene& s)const
    { return s.type()==AbstractScene::ARVE? new ArveAxes(m_size):0;
    }
private:
    float m_size;
};

PlottableModel* Axes::model()const
{
    // note that this is just a pointer to our own model object
    static Model model(m_scale);
    return &model;
}

