//  $Header: /cvs/tb_recon/graphics/GraphicsVector.h,v 1.1.1.1 2000/04/03 21:03:57 wilko Exp $
//  Author: Toby Burnett
//  Project: graphics
//
// Define a special 3-vector, for use by the drawing programs only
// Go to this trouble since we want to have a float representation for
// economy of virtural memory.

#ifndef VWVECTOR_H
#define VWVECTOR_H

#include "CLHEP/Vector/ThreeVector.h"

class GraphicsVector {
public:
	GraphicsVector(float x=0, float y=0, float z=0):m_x(x), m_y(y), m_z(z){}
	GraphicsVector(const Hep3Vector& v)
	: m_x(v.x()), m_y(v.y()), m_z(v.z()) {};

	float x()const{return m_x;}
	float y()const{return m_y;}
	float z()const{return m_z;}

	inline GraphicsVector& operator=(const GraphicsVector& rhs);

private:
	float m_x, m_y, m_z;
};

GraphicsVector& GraphicsVector::operator=(const GraphicsVector& rhs)
{
	m_x = rhs.x();
	m_y = rhs.y(); 
	m_z = rhs.z();
	return *this;
}
#endif
