
#ifndef CALADCLOGS_H
#define CALADCLOGS_H 1

#include "Event/trsDataVI.h"
#include "instrument/CalBase.h"
#include "instrument/CalLogID.h"

//##############################
class CalADCLog : public CalLogID
//##############################
{
public:

	// construct
	CalAnaLog(int ilayer, int iview, int column);
	~CalAnaLog() {};
                           {m_entries++;}
	void setNegADC(CalBase::RANGE r, double v)   {m_ADC[CalBase::NEG][r] += v;}
	void setPosADC(CalBase::RANGE r, double v)   {m_ADC[CalBase::POS][r] += v;}

	// access                          const {return m_entries;}
	double ADC(CalBase::SIDE s, CalBase::RANGE r) const {return m_ADC[s][r]}

	// operations
	void clear();
	void writeOut() const;

private:

	double m_ADC[CALNSIDES][CALNRANGES];
};

//##############################
class CalADCLogs : public trsDataVI
//##############################
{
public:

	// constructor
	CalADCLogs() {ini();}
	~CalADCLogs();

	// access
	int num()                 const {return m_List.size();}
	CalADCLog* Log(int i)     const {return m_List[i];}
	CalADCLog* getLog(int logID) const;

	// operation
	virtual void clear();
	virtual void make() {}

	virtual void writeOut() const;

protected:

	virtual void ini();

private:

	std::vector<CalADCLog*> m_List;
};
#endif
