
#ifndef GEO_H
#define GEO_H

#include "geometry/Point.h"
#include <string>

//##############################################
class Geo
//##############################################
{
public:
	// construct
	Geo(Point p = Point(0.,0.,0.), Point s=Point(0.,0.,0))
		: m_position(p),m_size(s) {}
	void setGeo(Point p, Point s);
	void setPosition(Point p)   {m_position = p;};
	void setSize(Point s)       {m_size = s;};

	// access
	Point position() const  {return m_position;}
	Point size() const      {return m_size;}

private:

	Point m_position;
	Point m_size;
};

//##############################################
class MatGeo : public Geo
//##############################################
{
public:

	// construct
	MatGeo(){}
	MatGeo(Point p, Point s):m_material("vacuum"),m_X0(0), Geo(p,s){}
	MatGeo(std::string name, double d, Point p, Point s):m_material("vacuum"),
		m_X0(0), Geo(p,s){}
	void setMaterial(std::string name, double d);

	// access
	std::string material() const  {return m_material;}
	double X0() const        {return m_X0;}
	double radLen();

private:

	std::string   m_material;
	double        m_X0;
};
#endif
