#include "instrument/SiCalibLayers.h"
#include "Event/messageManager.h"

//#######################################
bool SiCalibLayers::isBadStrip(int klayer, int iview, int istrip)
//#######################################
{
	bool bad = false;
	if (getSiLayer(klayer,iview) != 0) {
		SiLayer* slayer = getSiLayer(klayer,iview);
		int nstrips = slayer->nstrips();
		for (int j=0; j < nstrips; j++) {
			if (slayer->idstrip(j) == istrip) bad=true;
		}
	}
	if (bad) {
		int hola = 1;
	}
	return bad;
}
//#######################################
SiCalibLayers::SiCalibLayers()
//#######################################
{
	m_fileName="";
	SiLayers::ini();
	setName("SiCalibLayers");
}
//#######################################
void SiCalibLayers::readFromFile()
//#######################################
{
	messageManager::instance()->message
	(" Bad Strip List File : "+m_fileName);
	if (m_fileName == "") return;
	
	std::ifstream file (m_fileName.c_str() );
	int ilayer = 0;
	int istrip = 0;
	while(!file.eof()) {
		file >> ilayer;
		file >> istrip;
		addBadStrip(ilayer,istrip);
	}
	file.close();
}
//#######################################
void SiCalibLayers::addBadStrip(int klayer, int kstrip)
//#######################################
{
	int ilayer = (int) klayer/2;
	int iview = 0;
	if (ilayer%2 == 0 && klayer%2 == 0) iview = 1;
	if (ilayer%2 == 1 && klayer%2 == 1) iview = 1;
	if (getSiLayer(ilayer,iview) == 0) {
		SiLayer* slayer = new SiLayer(ilayer, iview);
		add(slayer);
	}
	SiLayer* slayer = getSiLayer(ilayer,iview);
	slayer->addStrip(kstrip);
}
