#ifndef SiCalibLayers_h
#define SiCalibLayers_h

#include "Event/serviceI.h"
#include "generation/SiLayers.h"

//--------------------------------
//! calibration data class for the bad strips
//--------------------------------

//################################
class SiCalibLayers: public SiLayers, public serviceI
//################################
{
public:

	//! constructor 
	SiCalibLayers();
	//! destructor
	~SiCalibLayers() {SiLayers::clear();}

	//! returns true is if the strip is a bad strip
	bool isBadStrip(int ilayer, int iview, int istrip);

	//! read the bad strips from a file
	virtual void make() {SiLayers::clear();readFromFile();SiLayers::writeOut();}

protected:

	void readFromFile();

	void defineOption() {optionVI::defineOption("badStripsFileName",&m_fileName);}

private:

	void addBadStrip(int ilayer, int istrip);

private:

	std::string m_fileName;
};
#endif