
#include "instrument/SiGeoCalib.h"
#include "Event/messageManager.h"

//####################################
void SiGeoCalib::ini()
//####################################
{
	m_fileName = "";
	clear();
}
//####################################
void SiGeoCalib::clear()
//####################################
{
	Point pNull(0.,0.,0);
	navigator<detGeo*>* nav = getNavigator();
	int num = nav->size();
	for (int i = 0; i< num; i++) nav->el(i)->setGeo(pNull,pNull);
}
//####################################
void SiGeoCalib::make()
//####################################
{
	messageManager::instance()->message
		(" Tracker Aligment file : "+m_fileName);
	if (m_fileName == "") return;

	std::ifstream file(m_fileName.c_str());

	std::string name = "";
	while(!file.eof()) {
		file >> name;
		if (name == "Layer")  readLayer(file);
		if (name == "Ladder") readLadder(file);
	}
	file.close();
}

//################################################
void SiGeoCalib::readLayer(std::istream& file)
//################################################
{
	int ilayer = 0;
	int iview = 0;
	double x,y,z;
	x=y=z=0.;
	double ax,ay,az;
	ax=ay=az=0.;

	file >> ilayer;
	file >> iview;
	file >> x,y,z;
	Point Offset(x,y,z);
	file >> ax,ay,az;
	Point Angle(ax,ay,az);

	detGeo* geo = getLayer(ilayer,detGeo::makeAxis(iview));
	geo->setGeo(Offset,Angle);
}

//################################################
void SiGeoCalib::readLadder(std::istream& file)
//################################################
{	
	int ilayer = 0;
	int iview = 0;
	int iladder = 0;
	double x,y,z;
	x=y=z=0.;
	double ax,ay,az;
	ax=ay=az=0.;

	file >> ilayer;
	file >> iview;
	file >> iladder;
	file >> x,y,z;
	Point Offset(x,y,z);
	file >> ax,ay,az;
	Point Angle(ax,ay,az);

	detGeo* geo = getLadder(ilayer,detGeo::makeAxis(iview), iladder);
	geo->setGeo(Offset,Angle);
}
//###############################################
void SiGeoCalib::defineOption()
//###############################################
{
	optionVI::defineOption("SiFile",&m_fileName);
}
