
#ifndef calorimeterDetGeo_H
#define calorimeterDetGeo_H 1

#include "instrument/navigator.h"
#include "instrument/detGeo.h"
#include "instrument/calorimeterGeo.h"
#include <stdlib.h>
#include <iostream>
#include <fstream>

//##########################################################
class calorimeterDetGeo : public calorimeterGeo
//##########################################################
{
public:

	// constructor
	calorimeterDetGeo();
	~calorimeterDetGeo();

	// access
	detGeo* getLayer(int ilayer, detGeo::axis a) 
		const {return getNavigator(ilayer,a)->el();}                  
	detGeo* getLog(int ilayer, detGeo::axis a, int ilog) 
		const {return getNavigator(ilayer,a,ilog)->el();}
	
	// operations
	void update(ArvePlottableRep& v) {draw(v);};
	void writeOut() const;

private:

	//constructior
	void createNav();
	void createCal();
	void createLayer(int ilayer, detGeo::axis a);
	void createLog(int ilayer, detGeo::axis a, int ilog);

	// access
	navigator<detGeo*>* getNavigator() const {return m_calorimeterNav;}
	navigator<detGeo*>* getNavigator(detGeo::axis a) const;
	navigator<detGeo*>* getNavigator(int ilayer, detGeo::axis a) const;
	navigator<detGeo*>* getNavigator(int ilayer, detGeo::axis a, int ilog) const;

	// operations
	void draw(ArvePlottableRep& v);
	void orderLayers();

private:

	std::string  m_nameOut;
	navigator<detGeo*>* m_calorimeterNav;

};


#endif
