
#ifndef __detGeo_H
#define __detGeo_H 1

#include <vector>
#include <string>
#include "instrument/Geo.h"
#include "geometry/Point.h"
#include "graphics/ArvePlottableRep.h"



//##############################################
class detGeo : public MatGeo
//##############################################
{
public:

	friend class trackerGeo;
	enum axis {X,Y,PASSIVE};

public:

	// construct
	detGeo(int ilayer, axis a, int id, Point p, Point s):m_layer(ilayer),
		m_axis(a), m_id(id), MatGeo(p,s) {}
	detGeo(int ilayer, axis a, int id): m_layer(ilayer),
		m_axis(a), m_id(id), MatGeo() {}
	~detGeo() {};
	void setName(std::string n)  {m_name = n;}

	// access
//	type getType() const        {return m_type;}
	int layer()            const {return m_layer;}
	axis getAxis()         const {return m_axis;}
	int id()               const {return m_id;}
	std::string name()     const {return m_name;}

	// operations
	static detGeo::axis makeAxis(int i) {return (i == 0? detGeo::X : detGeo::Y);}
	static int makeAxis(detGeo::axis a) {return (int) a;}
	void writeOut() const;
	void draw(ArvePlottableRep& v) const;

private:

	std::string m_name;
	int m_layer;
	axis m_axis;
	int m_id;

};

#endif
