
#ifndef NAVIGATOR_H
#define NAVIGATOR_H

#include <vector>
#include <string>

template <class T>

//################################
class navigator 
//################################
{
public:

	// construct
	navigator(T t, std::string n):m_T(t),m_name(n) {clear();};
	~navigator() {m_downList.clear();}

	void add(T t, std::string n)      {
		navigator<T>* navi = new navigator(t,n);
		navi->setUp(this);
		m_downList.push_back(navi);};
	void setUp(T t, std::string n)    {m_up = new navigator(t,n);};
	void setNext(T t, std::string n)  {m_next = new navigator(t,n);};
	void setPrev(T t, std::string n)  {m_prev = new navigator(t,n);};

	void add(navigator<T>* n)         {
		n->setUp(this);
		m_downList.push_back(n);};
	void setUp(navigator<T>* n)       {m_up = n;}
	void setNext(navigator<T>* n)     {m_next = n;}
	void setPrev(navigator<T>* n)     {m_prev = n;}

	// access
	int sizeDown()       {return m_downList.size();}
	std::string name()   {return m_name;}

	T& el()                          {return m_T;};
	T& el(int jEl)                   {return nav(jEl)->el();}
	T& elDown(int i)                 {return m_downList[i]->el();}
	T& elUp()                        {return m_up->el();}
	T& elNext()                      {return m_next->el();}
	T& elPrev()                      {return m_prev->el();}
	T& el(std::string userName, int jEl) {return nav(userName,jEl)->el();}

	navigator<T>* nav()          {return this;}
	navigator<T>* navDown(int i) {return m_downList[i];}
	navigator<T>* navUp()        {return m_up;}
	navigator<T>* navNext()      {return m_next;}
	navigator<T>* navPrev()      {return m_prev;}

private:

	std::string m_name;

	T m_T;
	navigator<T>* m_up;
	navigator<T>* m_next;
	navigator<T>* m_prev;
	std::vector<navigator<T>*> m_downList;

public:
	
	// operations
	//------------------
	void clear() {
		m_next = 0;
		m_up = 0;
		m_prev = 0;
		m_downList.clear();
	}
	//------------------
	
	//-----------------------------
	int size(std::string userName)
	{
		int iEl = 0;
		size(userName,iEl);
		return iEl;
	};
	//-----------------------------
	
	//-----------------------------
	int size()
	{
		int iEl = 0;
		size(iEl);
		return iEl;
	};
	//-----------------------------

	//-----------------------------
	navigator<T>* nav(std::string userName, int jEl)
	{
		int iEl = -1;
		bool found = false;
		return nav(userName,jEl,iEl, found);
	}
	//-----------------------------

	//-----------------------------
	navigator<T>* nav(int jEl)
	{
		int iEl = -1;
		bool found = false;
		return nav(jEl,iEl,found);
	}
	//-----------------------------

	//-----------------------------
	navigator<T>* front(std::string userName)
	{
		navigator<T>* navi = nav(userName,0);
		while (navi->navPrev() != 0) navi = navi->navPrev();
		return navi;
	}
	//-----------------------------
	//-----------------------------
	navigator<T>* back(std::string userName)
	{
		navigator<T>* navi = nav(userName,0);
		while (navi->navNext() != 0) navi = navi->navNext();
		return navi;
	}
	//-----------------------------

private:

	//-----------------------------
	void size(std::string userName, int& iEl) 
	{
		if (name() == userName) iEl++;
		else {	
			for (unsigned int i = 0; i < sizeDown(); i++) 
				navDown(i)->size(userName,iEl);
		}
	};
	//-----------------------------

	//-----------------------------
	void size(int& iEl) 
	{
		iEl++;
		for (unsigned int i = 0; i < sizeDown(); i++) navDown(i)->size(iEl);
	};
	//-----------------------------

	//-----------------------------
	navigator<T>* nav(std::string userName, int jEl, int& iEl, bool& found)
	{
		if (name() == userName) {	
			iEl++;
			if (iEl == jEl) {
				found = true;
				return this;
			}
		}
		else {
			unsigned int i = 0;
			while (!found && i < sizeDown()) {
				navigator<T>* navi =  navDown(i)->nav(userName, jEl, iEl, found);
				if (found) return navi;
				i++;
			}
		}
		navigator<T>* navi = 0;
		return navi;
	}
	//-----------------------------
	
	//-----------------------------
	navigator<T>* nav(int jEl, int& iEl, bool& found)
	{
		iEl++;
		if (iEl == jEl) {
			found = true;
			return this;
		}
		unsigned int i = 0;
		while (!found && i < sizeDown()) {
			navigator<T>* navi = navDown(i)->nav(jEl, iEl, found);
			if (found) return navi;
			i++;
		}
		navigator<T>* navi = 0;
		return navi;
	}
	//-----------------------------
};
#endif
