
#ifndef TRACKERDETGEO_H
#define TRACKERDETGEO_H

#include "instrument/navigator.h"
#include "instrument/detGeo.h"
#include "instrument/trackerGeo.h"
#include <stdlib.h>
#include <iostream>
#include <fstream>


//############################
class trackerDetGeo : trackerGeo
//############################
{
public:

	// construct
	trackerDetGeo();
	~trackerDetGeo();

	// access                 
	detGeo* getLayer(int ilayer, detGeo::axis a)           
	const {return getNavigator(ilayer,a)->el();}                  
	detGeo* getLadder(int ilayer, detGeo::axis a, int iladder)  
	const {return getNavigator(ilayer,a,iladder)->el();}                 
	detGeo* getDice(int ilayer, detGeo::axis a, int iladder, int idice) 
	const {return getNavigator(ilayer,a,iladder,idice)->el();}
	
	// operations
	void update(ArvePlottableRep& v) {draw(v);}
	void writeOut() const;

protected:

	// access
	navigator<detGeo*>* getNavigator() const {return m_trackerNav;};
	navigator<detGeo*>* getNavigator(detGeo::axis a)  const;
	navigator<detGeo*>* getNavigator(int ilayer, detGeo::axis a) const;
	navigator<detGeo*>* getNavigator(int ilayer, detGeo::axis a, int iladder) const;
	navigator<detGeo*>* getNavigator(int ilayer, detGeo::axis a, int iladder,int idice) const;

	// operations
	void draw(ArvePlottableRep& v);

private:

	// constructor
	void createNav();
	void createTrk();
	void createSiLayer(int ilayer, detGeo::axis a);
	void createPbLayer(int ilayer);
	void createLadder(int ilayer, detGeo::axis a, int iladder);
	void createDice(int ilayer, detGeo::axis, int iladder, int idice);

	// operations
	void orderLayers();

private:

	std::string  m_nameOut;
	navigator<detGeo*>* m_trackerNav;

};

#endif
