
#include "instrument/trackerGeo.h"

//--------------- parameters -----------------------
int trackerGeo::m_nviews  = 2;
int trackerGeo::m_nlayers = 16;
int trackerGeo::m_nPbLayers = 14;
int trackerGeo::m_nSuperGLayers = 3;
int trackerGeo::m_Z0        = 0;

double trackerGeo::m_trayWidth   = 32.08;
double trackerGeo::m_trayHeight   = 3.20802;

double trackerGeo::m_pbX0           = 0.56;

double trackerGeo::m_ladderWidth    = 6.4;
double trackerGeo::m_ladderLength   = 32.08; 
double trackerGeo::m_ladderGap      = 0.02;
double trackerGeo::m_ladderInnerGap = 0.003;
int    trackerGeo::m_ladderNStrips  = 320; 

double trackerGeo::m_siStripPitch   = 0.0194;
double trackerGeo::m_siResolution   = 0.0056;
double trackerGeo::m_siThickness    = 0.0400;
double trackerGeo::m_siDeadDistance = 0.1057;
double trackerGeo::m_siX0           = 9.3600;
//----------------------------------------------------


//-------------- static --------------------------

//################################################
double trackerGeo::pbRadLen(int ilayer)
//################################################
{
	double radlen = 0.;
	if (ilayer < numLayers()-numPbLayers()) radlen = 0.;
	else if (ilayer < numLayers()-numPbLayers()+numSuperGLayers()) radlen = 0.25;
	else radlen = 0.035;

	return radlen;
}
//################################################
double trackerGeo::layerGap(int ilayer)
//################################################
{
	double zgap = 0.249;
	if (ilayer < 5) zgap = 0.274;
	return zgap;
}
//################################################
int trackerGeo::nLadders(int ilayer, detGeo::axis a)
//################################################
{
	int nladders = 5;
	if (ilayer > 8 ) nladders = 3;
	if (ilayer == 8) nladders = 4;

	return nladders;
}
//################################################
double trackerGeo::diceSize(int ilayer, detGeo::axis a, int iladder)
//################################################
{
	double size = 10.667;
	if (ilayer > 8 ) size = 6.4;
	if (ilayer == 8 && a == detGeo::X) size = 6.4;  
	if (ilayer == 7 && a == detGeo::Y) size = 6.4;
	if (ilayer == 14 && a == detGeo::Y && iladder == 0) size = 10.667;

	return size;
}

//################################################
int trackerGeo::nDices(int ilayer,detGeo::axis a,int iladder)
//################################################
{
	int ndices = 5;
	double size = trackerGeo::diceSize(ilayer,a, iladder);
	if (size == 10.667) ndices = 3;

	return ndices;
}
