

#ifndef __CALRECLOGSALG_H
#define __CALRECLOGSALG_H 1

#include "Event/algorithmVI.h"

class calorimeterDetGeo;
class CalPedCalib;
class CalCalibLogs;
class CalCalibLog;

class CalADCLogs;
class CalRecLogs;

class CalRecLog;
class CalADCLog;
class detGeo;

//----------------------------------------------
//
//   CalRecLogsAlg
//
//   Algorithm Data constructor of CalRecLogs
//----------------------------------------------
//             J.A Hernando, Santa Cruz 02/29/00
//----------------------------------------------
//##########################################################
class CalRecLogsAlg : public algorithmVI
//##########################################################
{
public:

	// constructor
	CalRecLogsAlg() {}
	~CalRecLogsAlg() {}

	// operations
	virtual void initialize();
	virtual void execute();
	virtual void finalize();

private:

	void computeEnergy(CalRecLog* recLog, const CalADCLog* adcLog, 
		const CalADCLog* pedLog, const CalCalibLog* calibLog);
	void computePosition(CalRecLog* recLog, const detGeo* geoLog,
		const CalCalibLog* calibLog);

private:

	const calorimeterDetGeo* m_CalGeoLogs;
	const CalPedCalib* m_CalPedLogs;
	const CalCalibLogs* m_CalCalibLogs;
	const CalADCLogs* m_CalRawLogs;

	CalRecLogs* m_CalRecLogs;

};
      
#endif
