
#ifndef __SICLUSTERALG_H
#define __SICLUSTERALG_H 1

#include <vector>
#include "geometry/Point.h"
#include "instrument/SiCalibLayers.h"
#include "generation/SiLayers.h"
#include "reconstruction/SiClusters.h"
#include "Event/algorithmVI.h"
#include "Event/defineVI.h"

class SiLayers;

//----------------------------------------------
//
//   SiClustersAlg
//
//   Algorithm Data constructor of SiClusterAlg
//----------------------------------------------
//             J.A Hernando, Santa Cruz 02/29/00
//----------------------------------------------
//##########################################################
class SiClustersAlg : public algorithmVI, public defineVI
//##########################################################
{
public:
	// constructor
	SiClustersAlg() {}
	~SiClustersAlg() {}

	virtual void initialize();
	virtual void execute();
	virtual void finalize();

	virtual void define();

protected:

	static Point position(int ilayer, SiCluster::view v, double strip);

private:

	SiLayers* m_SiLayers;
	SiCalibLayers* m_SiCalibLayers;
	SiClusters* m_SiClusters;
};
      
#endif
