
#ifndef __SIRECOBJS_H
#define __SIRECOBJS_H 1

#include <vector>
#include "reconstruction/GFcandidates.h"

//----------------------------------------------
//
//   SiRecObhs
//
//   Transient Storage Data
//----------------------------------------------
//   It contains the high level recostructed objects
//  of the tracker (gammas and tracks)
//----------------------------------------------
//             J.A Hernando, Santa Cruz 02/29/00
//----------------------------------------------
//##########################################################
class SiRecObjs : public trsDataVI
//##########################################################
{

public:

	// constructor
	SiRecObjs()  {ini();}
	~SiRecObjs() {clear();}
	
	void addGamma(GFgamma* g)       {m_GFgammaList.push_back(g);}
	void addParticle(GFparticle* p) {m_GFparticleList.push_back(p);}

	// access List
	int numGammas() const					    {return m_GFgammaList.size();}
	GFgamma*  Gamma(int i)   const              {return m_GFgammaList[i];}
	int numParticles() const				    {return m_GFparticleList.size();}
	GFparticle* Particle(int i) const			{return m_GFparticleList[i];}
	
	// external operations
	void update(ArvePlottableRep& v) {draw(v);}

	virtual void clear();
	virtual void make() {}
	virtual void writeOut() const;

private:

	virtual void ini();
	// operations
	void draw(ArvePlottableRep& v);

private:

	// track information
	std::vector<GFparticle*> m_GFparticleList;
	std::vector<GFgamma*> m_GFgammaList;
};
      
#endif
