//-------------------------------------------------------------------
//
//     SiRecObjsAlg:
//
//          Steers the Silicon-Tracker Reconstruction    
//
//                    Bill Atwood
//                    B. Atwood, JA Hernando, Santa Cruz, 02/05/99
//
//-------------------------------------------------------------------

#ifndef __SIRECOBJSALG_H
#define __SIRECOBJSALG_H 1

#include "geometry/Point.h"
#include "Event/algorithmVI.h"
#include "Event/defineVI.h"

class SiClusters;
class SiRecObjs;

//----------------------------------------------
//
//   SiRecObjsAlg
//
//   Algorithm Data constructor of SiRecObjs
//----------------------------------------------
//             J.A Hernando, Santa Cruz 02/29/00
//----------------------------------------------
//##########################################################
class SiRecObjsAlg : public algorithmVI, public defineVI
//##########################################################
{
public:

	// constructor
	SiRecObjsAlg() {}
	~SiRecObjsAlg() {}

	// algorimth virtual
	void initialize();
	void execute();
	void finalize();

	void define();

private:

    void searchGammas(); 
    void searchParticles();

private:

	// clusters information
	SiClusters* m_SiClusters;
	// tracking objects information
	SiRecObjs*  m_SiRecObjs;

	double m_CsIEnergy;
	Point m_CsIPosition;
};
      
#endif
