// $Id: WinGUIostream.cxx,v 1.1.1.1 2000/04/03 21:04:06 wilko Exp $

#include "WinGUI.h"
#include "winGUIostream.h"
#include "resource.h"

#include <errno.h>

#include <iostream>
#include <strstream>

//////////////////////////////////////////////////////////////////////
//          private streambuf used by WinGUIostream
class logbuf : public std::streambuf
{
public:
    logbuf (HWND owner);
    virtual ~logbuf ();

    virtual int	overflow (int c);
    virtual int	underflow ();

private:
    HWND _win;

};
    static std::streambuf* sbout=0;
    static std::streambuf* sberr=0;

//////////////////////////////////////////////////////////////////////
//         WINGUIostream implementations
//////////////////////////////////////////////////////////////////////
//                constructor
WinGUIostream::WinGUIostream(const char* name, HWND owner, HINSTANCE hInstance)
: GUIostream(_buf = new logbuf(owner))
{
    BOOL test = FreeConsole();  // in case started from the command line
    AllocConsole();
    // direct cout and cerr to the console window
    std::streambuf* sbout = std::cout.rdbuf();
    std::streambuf* sberr = std::cerr.rdbuf();
    std::cout.rdbuf(_buf);
    std::cerr.rdbuf(_buf);

 }
//------------------------------------------------------------------------
WinGUIostream::~WinGUIostream()
{
    // restore the rdbufs for system cleanup
    std::cout.rdbuf(sbout);
    std::cerr.rdbuf(sberr);
    delete _buf;
}
//------------------------------------------------------------------------
//                        flush
void WinGUIostream::flush()
{
    ostream::flush();
    // TODO: do I need this now?
}
//------------------------------------------------------------------------
//                           clear

void WinGUIostream::clear()
{
    //TODO: figure out how to clear console
   flush();

}
//////////////////////////////////////////////////////////////////////////////
//            logbuf implementations
//////////////////////////////////////////////////////////////////////////////

const int LOGBUF_SIZE = 32;

//#doc		Initializes the log buffer.
logbuf::logbuf (HWND owner): _win(owner)
{
	setp (0, 0);
	setg (0, 0, 0);
}

logbuf::~logbuf ()
{ }

int logbuf::underflow () { return traits_type::eof (); }

int logbuf::overflow (int c)
{
    if (c != traits_type::eof ())
    {
        char string [3] = {c, '\0', '\0'};
	int length = 1;
	
	if (c == '\n') {
	    string [0] = '\r';
	    string [1] = '\n';
	    ++length;
	}
	unsigned long numwritten;
	::WriteFile(GetStdHandle(STD_OUTPUT_HANDLE), string, length, &numwritten, NULL);
    }
    return 0;
}


