//     $Id: WinScene.cxx,v 1.1.1.1 2000/04/03 21:04:06 wilko Exp $
//  Author: T. Burnett
// Project: Arve graphics
//
// Implement the WinScene widget
#include "WinScene.h"
#include "WinDraw.h"
#include "graphics/Projector.h"


WinScene::WinScene(HWND win, float size )
 : SceneControl(m_proj = new Projector(m_wd= new WinDraw(win)),size )
{
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WinScene::~WinScene()
{
    delete m_wd;
    delete m_proj;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void WinScene::redisplay()
// force redraw of this window--schedules a WM_PAINT message
{
    m_wd->invalidate();
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void  WinScene::redisplay(HDC hdc)
// respond to WM_PAINT message to main window
{   
    m_wd->setHDC(hdc);
    SceneControl::redisplay();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void WinScene::print_commands(std::ostream& out)
{
   out << 
"\n"
"Mouse commands\n"
"==============================\n"
"left botton click: \t center at mouse position\n"
"right botton click: \t magnify\n"
"\n"
"Special Keys\n"
"============\n"
"arrows:    move reference point in selected view\n"
"PgUp/PgDn: increase/decrease magnification\n"
"Home:      reset selected view\n" 
;
    SceneControl::print_commands(out);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void WinScene::mouseClick(int ix, int iy)
{
    move_by(m_wd->xnorm(ix), m_wd->ynorm(iy));
    redisplay();
}

